OGRE-Next: Ogre::cbitset64< _N > Class Template Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::cbitset64< _N > Class Template Reference
Core

This is similar to std::bitset, except waaay less bloat. More...

`#include <OgreBitset.h>`

Inheritance diagram for Ogre::cbitset64< _N >:
[legend]

## Public Member Functions
size_t | findFirstBitSet () const
| Finds the first bit set.
size_t | findLastBitSetPlusOne () const
| Finds the first bit unset after the last bit set.
Public Member Functions inherited from Ogre::cbitsetN< _N, uint64, 6u, 0x3Fu >
| cbitsetN ()
size_t | capacity () const
| Return maximum number of bits this bitset can hold.
void | clear ()
| Sets all bits to 0.
bool | empty () const
| Returns true if all bits are unset.
size_t | numBitsSet (const size_t positionEnd) const
| Returns the number of bits that are set between range [0; positionEnd).
void | set (const size_t position)
| Sets bit at 'position' to 1.
void | setAll ()
| Sets all bits to 1.
void | setAllUntil (size_t position)
| Sets all bits in range [0; position) It's the same as calling:
void | setValue (const size_t position, const bool bValue)
| Sets bit at 'position'.
bool | test (const size_t position) const
| Returns true if bit at 'position' is 1.
void | unset (const size_t position)
| Sets bit at 'position' to 0.

## Detailed Description

template<size_t _N>
class Ogre::cbitset64< _N >

This is similar to std::bitset, except waaay less bloat.

cbitset64 stands for constant/compile-time bitset with an internal representation of 64-bits

2^6 = 64 0x3F = 64 - 1 = 6 bits set

Remarks
  IMPORTANT: To use this class, you MUST include OgreBitset.inl in your cpp file This split into *.h and *.inl was to avoid bloating build times of headers that include OgreBitset.h

Parameters

  _N | Number of bits this bitset will hold

## Member Function Documentation

## ◆ findFirstBitSet()

template<size_t _N>

size_t Ogre::cbitset64< _N >::findFirstBitSet | ( |  | ) | const

Finds the first bit set.

Returns
  The index to the first unset bit returns this->capacity() if all bits are unset (i.e. all 0s)

## ◆ findLastBitSetPlusOne()

template<size_t _N>

size_t Ogre::cbitset64< _N >::findLastBitSetPlusOne | ( |  | ) | const

Finds the first bit unset after the last bit set.

Returns
  If all bits are unset (i.e. all 0s): Returns 0 If at least one bit is set: The index to the last set bit, plus one. Return range is [1; capacity]

The documentation for this class was generated from the following file:

- OgreBitset.h